t / test-lib.shon commit Merge branch 'tr/merge-edit-guidance' into maint (4eed30a)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset EMAIL
  47unset LANGUAGE
  48unset $(perl -e '
  49        my @env = keys %ENV;
  50        my $ok = join("|", qw(
  51                TRACE
  52                DEBUG
  53                USE_LOOKUP
  54                TEST
  55                .*_TEST
  56                PROVE
  57                VALGRIND
  58        ));
  59        my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
  60        print join("\n", @vars);
  61')
  62GIT_AUTHOR_EMAIL=author@example.com
  63GIT_AUTHOR_NAME='A U Thor'
  64GIT_COMMITTER_EMAIL=committer@example.com
  65GIT_COMMITTER_NAME='C O Mitter'
  66GIT_MERGE_VERBOSITY=5
  67export GIT_MERGE_VERBOSITY
  68export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  69export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  70export EDITOR
  71
  72# Protect ourselves from common misconfiguration to export
  73# CDPATH into the environment
  74unset CDPATH
  75
  76unset GREP_OPTIONS
  77
  78case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  79        1|2|true)
  80                echo "* warning: Some tests will not work if GIT_TRACE" \
  81                        "is set as to trace on STDERR ! *"
  82                echo "* warning: Please set GIT_TRACE to something" \
  83                        "other than 1, 2 or true ! *"
  84                ;;
  85esac
  86
  87# Convenience
  88#
  89# A regexp to match 5 and 40 hexdigits
  90_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  91_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  92
  93# Zero SHA-1
  94_z40=0000000000000000000000000000000000000000
  95
  96# Line feed
  97LF='
  98'
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195exec 6<&0
 196if test "$verbose" = "t"
 197then
 198        exec 4>&2 3>&1
 199else
 200        exec 4>/dev/null 3>/dev/null
 201fi
 202
 203test_failure=0
 204test_count=0
 205test_fixed=0
 206test_broken=0
 207test_success=0
 208
 209test_external_has_tap=0
 210
 211die () {
 212        code=$?
 213        if test -n "$GIT_EXIT_OK"
 214        then
 215                exit $code
 216        else
 217                echo >&5 "FATAL: Unexpected exit with code $code"
 218                exit 1
 219        fi
 220}
 221
 222GIT_EXIT_OK=
 223trap 'die' EXIT
 224
 225# The semantics of the editor variables are that of invoking
 226# sh -c "$EDITOR \"$@\"" files ...
 227#
 228# If our trash directory contains shell metacharacters, they will be
 229# interpreted if we just set $EDITOR directly, so do a little dance with
 230# environment variables to work around this.
 231#
 232# In particular, quoting isn't enough, as the path may contain the same quote
 233# that we're using.
 234test_set_editor () {
 235        FAKE_EDITOR="$1"
 236        export FAKE_EDITOR
 237        EDITOR='"$FAKE_EDITOR"'
 238        export EDITOR
 239}
 240
 241test_decode_color () {
 242        awk '
 243                function name(n) {
 244                        if (n == 0) return "RESET";
 245                        if (n == 1) return "BOLD";
 246                        if (n == 30) return "BLACK";
 247                        if (n == 31) return "RED";
 248                        if (n == 32) return "GREEN";
 249                        if (n == 33) return "YELLOW";
 250                        if (n == 34) return "BLUE";
 251                        if (n == 35) return "MAGENTA";
 252                        if (n == 36) return "CYAN";
 253                        if (n == 37) return "WHITE";
 254                        if (n == 40) return "BLACK";
 255                        if (n == 41) return "BRED";
 256                        if (n == 42) return "BGREEN";
 257                        if (n == 43) return "BYELLOW";
 258                        if (n == 44) return "BBLUE";
 259                        if (n == 45) return "BMAGENTA";
 260                        if (n == 46) return "BCYAN";
 261                        if (n == 47) return "BWHITE";
 262                }
 263                {
 264                        while (match($0, /\033\[[0-9;]*m/) != 0) {
 265                                printf "%s<", substr($0, 1, RSTART-1);
 266                                codes = substr($0, RSTART+2, RLENGTH-3);
 267                                if (length(codes) == 0)
 268                                        printf "%s", name(0)
 269                                else {
 270                                        n = split(codes, ary, ";");
 271                                        sep = "";
 272                                        for (i = 1; i <= n; i++) {
 273                                                printf "%s%s", sep, name(ary[i]);
 274                                                sep = ";"
 275                                        }
 276                                }
 277                                printf ">";
 278                                $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
 279                        }
 280                        print
 281                }
 282        '
 283}
 284
 285nul_to_q () {
 286        perl -pe 'y/\000/Q/'
 287}
 288
 289q_to_nul () {
 290        perl -pe 'y/Q/\000/'
 291}
 292
 293q_to_cr () {
 294        tr Q '\015'
 295}
 296
 297q_to_tab () {
 298        tr Q '\011'
 299}
 300
 301append_cr () {
 302        sed -e 's/$/Q/' | tr Q '\015'
 303}
 304
 305remove_cr () {
 306        tr '\015' Q | sed -e 's/Q$//'
 307}
 308
 309# In some bourne shell implementations, the "unset" builtin returns
 310# nonzero status when a variable to be unset was not set in the first
 311# place.
 312#
 313# Use sane_unset when that should not be considered an error.
 314
 315sane_unset () {
 316        unset "$@"
 317        return 0
 318}
 319
 320test_tick () {
 321        if test -z "${test_tick+set}"
 322        then
 323                test_tick=1112911993
 324        else
 325                test_tick=$(($test_tick + 60))
 326        fi
 327        GIT_COMMITTER_DATE="$test_tick -0700"
 328        GIT_AUTHOR_DATE="$test_tick -0700"
 329        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 330}
 331
 332# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 333#
 334# This will commit a file with the given contents and the given commit
 335# message.  It will also add a tag with <message> as name.
 336#
 337# Both <file> and <contents> default to <message>.
 338
 339test_commit () {
 340        file=${2:-"$1.t"}
 341        echo "${3-$1}" > "$file" &&
 342        git add "$file" &&
 343        test_tick &&
 344        git commit -m "$1" &&
 345        git tag "$1"
 346}
 347
 348# Call test_merge with the arguments "<message> <commit>", where <commit>
 349# can be a tag pointing to the commit-to-merge.
 350
 351test_merge () {
 352        test_tick &&
 353        git merge -m "$1" "$2" &&
 354        git tag "$1"
 355}
 356
 357# This function helps systems where core.filemode=false is set.
 358# Use it instead of plain 'chmod +x' to set or unset the executable bit
 359# of a file in the working directory and add it to the index.
 360
 361test_chmod () {
 362        chmod "$@" &&
 363        git update-index --add "--chmod=$@"
 364}
 365
 366# Unset a configuration variable, but don't fail if it doesn't exist.
 367test_unconfig () {
 368        git config --unset-all "$@"
 369        config_status=$?
 370        case "$config_status" in
 371        5) # ok, nothing to unset
 372                config_status=0
 373                ;;
 374        esac
 375        return $config_status
 376}
 377
 378# Set git config, automatically unsetting it after the test is over.
 379test_config () {
 380        test_when_finished "test_unconfig '$1'" &&
 381        git config "$@"
 382}
 383
 384
 385test_config_global () {
 386        test_when_finished "test_unconfig --global '$1'" &&
 387        git config --global "$@"
 388}
 389
 390write_script () {
 391        {
 392                echo "#!${2-"$SHELL_PATH"}" &&
 393                cat
 394        } >"$1" &&
 395        chmod +x "$1"
 396}
 397
 398# Use test_set_prereq to tell that a particular prerequisite is available.
 399# The prerequisite can later be checked for in two ways:
 400#
 401# - Explicitly using test_have_prereq.
 402#
 403# - Implicitly by specifying the prerequisite tag in the calls to
 404#   test_expect_{success,failure,code}.
 405#
 406# The single parameter is the prerequisite tag (a simple word, in all
 407# capital letters by convention).
 408
 409test_set_prereq () {
 410        satisfied="$satisfied$1 "
 411}
 412satisfied=" "
 413
 414test_have_prereq () {
 415        # prerequisites can be concatenated with ','
 416        save_IFS=$IFS
 417        IFS=,
 418        set -- $*
 419        IFS=$save_IFS
 420
 421        total_prereq=0
 422        ok_prereq=0
 423        missing_prereq=
 424
 425        for prerequisite
 426        do
 427                total_prereq=$(($total_prereq + 1))
 428                case $satisfied in
 429                *" $prerequisite "*)
 430                        ok_prereq=$(($ok_prereq + 1))
 431                        ;;
 432                *)
 433                        # Keep a list of missing prerequisites
 434                        if test -z "$missing_prereq"
 435                        then
 436                                missing_prereq=$prerequisite
 437                        else
 438                                missing_prereq="$prerequisite,$missing_prereq"
 439                        fi
 440                esac
 441        done
 442
 443        test $total_prereq = $ok_prereq
 444}
 445
 446test_declared_prereq () {
 447        case ",$test_prereq," in
 448        *,$1,*)
 449                return 0
 450                ;;
 451        esac
 452        return 1
 453}
 454
 455# You are not expected to call test_ok_ and test_failure_ directly, use
 456# the text_expect_* functions instead.
 457
 458test_ok_ () {
 459        test_success=$(($test_success + 1))
 460        say_color "" "ok $test_count - $@"
 461}
 462
 463test_failure_ () {
 464        test_failure=$(($test_failure + 1))
 465        say_color error "not ok - $test_count $1"
 466        shift
 467        echo "$@" | sed -e 's/^/#       /'
 468        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 469}
 470
 471test_known_broken_ok_ () {
 472        test_fixed=$(($test_fixed+1))
 473        say_color "" "ok $test_count - $@ # TODO known breakage"
 474}
 475
 476test_known_broken_failure_ () {
 477        test_broken=$(($test_broken+1))
 478        say_color skip "not ok $test_count - $@ # TODO known breakage"
 479}
 480
 481test_debug () {
 482        test "$debug" = "" || eval "$1"
 483}
 484
 485test_eval_ () {
 486        # This is a separate function because some tests use
 487        # "return" to end a test_expect_success block early.
 488        eval </dev/null >&3 2>&4 "$*"
 489}
 490
 491test_run_ () {
 492        test_cleanup=:
 493        expecting_failure=$2
 494        test_eval_ "$1"
 495        eval_ret=$?
 496
 497        if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
 498        then
 499                test_eval_ "$test_cleanup"
 500        fi
 501        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 502                echo ""
 503        fi
 504        return "$eval_ret"
 505}
 506
 507test_skip () {
 508        test_count=$(($test_count+1))
 509        to_skip=
 510        for skp in $GIT_SKIP_TESTS
 511        do
 512                case $this_test.$test_count in
 513                $skp)
 514                        to_skip=t
 515                        break
 516                esac
 517        done
 518        if test -z "$to_skip" && test -n "$test_prereq" &&
 519           ! test_have_prereq "$test_prereq"
 520        then
 521                to_skip=t
 522        fi
 523        case "$to_skip" in
 524        t)
 525                of_prereq=
 526                if test "$missing_prereq" != "$test_prereq"
 527                then
 528                        of_prereq=" of $test_prereq"
 529                fi
 530
 531                say_color skip >&3 "skipping test: $@"
 532                say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
 533                : true
 534                ;;
 535        *)
 536                false
 537                ;;
 538        esac
 539}
 540
 541test_expect_failure () {
 542        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 543        test "$#" = 2 ||
 544        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 545        export test_prereq
 546        if ! test_skip "$@"
 547        then
 548                say >&3 "checking known breakage: $2"
 549                if test_run_ "$2" expecting_failure
 550                then
 551                        test_known_broken_ok_ "$1"
 552                else
 553                        test_known_broken_failure_ "$1"
 554                fi
 555        fi
 556        echo >&3 ""
 557}
 558
 559test_expect_success () {
 560        test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
 561        test "$#" = 2 ||
 562        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 563        export test_prereq
 564        if ! test_skip "$@"
 565        then
 566                say >&3 "expecting success: $2"
 567                if test_run_ "$2"
 568                then
 569                        test_ok_ "$1"
 570                else
 571                        test_failure_ "$@"
 572                fi
 573        fi
 574        echo >&3 ""
 575}
 576
 577# test_external runs external test scripts that provide continuous
 578# test output about their progress, and succeeds/fails on
 579# zero/non-zero exit code.  It outputs the test output on stdout even
 580# in non-verbose mode, and announces the external script with "# run
 581# <n>: ..." before running it.  When providing relative paths, keep in
 582# mind that all scripts run in "trash directory".
 583# Usage: test_external description command arguments...
 584# Example: test_external 'Perl API' perl ../path/to/test.pl
 585test_external () {
 586        test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
 587        test "$#" = 3 ||
 588        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 589        descr="$1"
 590        shift
 591        export test_prereq
 592        if ! test_skip "$descr" "$@"
 593        then
 594                # Announce the script to reduce confusion about the
 595                # test output that follows.
 596                say_color "" "# run $test_count: $descr ($*)"
 597                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 598                # to be able to use them in script
 599                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 600                # Run command; redirect its stderr to &4 as in
 601                # test_run_, but keep its stdout on our stdout even in
 602                # non-verbose mode.
 603                "$@" 2>&4
 604                if [ "$?" = 0 ]
 605                then
 606                        if test $test_external_has_tap -eq 0; then
 607                                test_ok_ "$descr"
 608                        else
 609                                say_color "" "# test_external test $descr was ok"
 610                                test_success=$(($test_success + 1))
 611                        fi
 612                else
 613                        if test $test_external_has_tap -eq 0; then
 614                                test_failure_ "$descr" "$@"
 615                        else
 616                                say_color error "# test_external test $descr failed: $@"
 617                                test_failure=$(($test_failure + 1))
 618                        fi
 619                fi
 620        fi
 621}
 622
 623# Like test_external, but in addition tests that the command generated
 624# no output on stderr.
 625test_external_without_stderr () {
 626        # The temporary file has no (and must have no) security
 627        # implications.
 628        tmp=${TMPDIR:-/tmp}
 629        stderr="$tmp/git-external-stderr.$$.tmp"
 630        test_external "$@" 4> "$stderr"
 631        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 632        descr="no stderr: $1"
 633        shift
 634        say >&3 "# expecting no stderr from previous command"
 635        if [ ! -s "$stderr" ]; then
 636                rm "$stderr"
 637
 638                if test $test_external_has_tap -eq 0; then
 639                        test_ok_ "$descr"
 640                else
 641                        say_color "" "# test_external_without_stderr test $descr was ok"
 642                        test_success=$(($test_success + 1))
 643                fi
 644        else
 645                if [ "$verbose" = t ]; then
 646                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 647                else
 648                        output=
 649                fi
 650                # rm first in case test_failure exits.
 651                rm "$stderr"
 652                if test $test_external_has_tap -eq 0; then
 653                        test_failure_ "$descr" "$@" "$output"
 654                else
 655                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 656                        test_failure=$(($test_failure + 1))
 657                fi
 658        fi
 659}
 660
 661# debugging-friendly alternatives to "test [-f|-d|-e]"
 662# The commands test the existence or non-existence of $1. $2 can be
 663# given to provide a more precise diagnosis.
 664test_path_is_file () {
 665        if ! [ -f "$1" ]
 666        then
 667                echo "File $1 doesn't exist. $*"
 668                false
 669        fi
 670}
 671
 672test_path_is_dir () {
 673        if ! [ -d "$1" ]
 674        then
 675                echo "Directory $1 doesn't exist. $*"
 676                false
 677        fi
 678}
 679
 680test_path_is_missing () {
 681        if [ -e "$1" ]
 682        then
 683                echo "Path exists:"
 684                ls -ld "$1"
 685                if [ $# -ge 1 ]; then
 686                        echo "$*"
 687                fi
 688                false
 689        fi
 690}
 691
 692# test_line_count checks that a file has the number of lines it
 693# ought to. For example:
 694#
 695#       test_expect_success 'produce exactly one line of output' '
 696#               do something >output &&
 697#               test_line_count = 1 output
 698#       '
 699#
 700# is like "test $(wc -l <output) = 1" except that it passes the
 701# output through when the number of lines is wrong.
 702
 703test_line_count () {
 704        if test $# != 3
 705        then
 706                error "bug in the test script: not 3 parameters to test_line_count"
 707        elif ! test $(wc -l <"$3") "$1" "$2"
 708        then
 709                echo "test_line_count: line count for $3 !$1 $2"
 710                cat "$3"
 711                return 1
 712        fi
 713}
 714
 715# This is not among top-level (test_expect_success | test_expect_failure)
 716# but is a prefix that can be used in the test script, like:
 717#
 718#       test_expect_success 'complain and die' '
 719#           do something &&
 720#           do something else &&
 721#           test_must_fail git checkout ../outerspace
 722#       '
 723#
 724# Writing this as "! git checkout ../outerspace" is wrong, because
 725# the failure could be due to a segv.  We want a controlled failure.
 726
 727test_must_fail () {
 728        "$@"
 729        exit_code=$?
 730        if test $exit_code = 0; then
 731                echo >&2 "test_must_fail: command succeeded: $*"
 732                return 1
 733        elif test $exit_code -gt 129 -a $exit_code -le 192; then
 734                echo >&2 "test_must_fail: died by signal: $*"
 735                return 1
 736        elif test $exit_code = 127; then
 737                echo >&2 "test_must_fail: command not found: $*"
 738                return 1
 739        fi
 740        return 0
 741}
 742
 743# Similar to test_must_fail, but tolerates success, too.  This is
 744# meant to be used in contexts like:
 745#
 746#       test_expect_success 'some command works without configuration' '
 747#               test_might_fail git config --unset all.configuration &&
 748#               do something
 749#       '
 750#
 751# Writing "git config --unset all.configuration || :" would be wrong,
 752# because we want to notice if it fails due to segv.
 753
 754test_might_fail () {
 755        "$@"
 756        exit_code=$?
 757        if test $exit_code -gt 129 -a $exit_code -le 192; then
 758                echo >&2 "test_might_fail: died by signal: $*"
 759                return 1
 760        elif test $exit_code = 127; then
 761                echo >&2 "test_might_fail: command not found: $*"
 762                return 1
 763        fi
 764        return 0
 765}
 766
 767# Similar to test_must_fail and test_might_fail, but check that a
 768# given command exited with a given exit code. Meant to be used as:
 769#
 770#       test_expect_success 'Merge with d/f conflicts' '
 771#               test_expect_code 1 git merge "merge msg" B master
 772#       '
 773
 774test_expect_code () {
 775        want_code=$1
 776        shift
 777        "$@"
 778        exit_code=$?
 779        if test $exit_code = $want_code
 780        then
 781                return 0
 782        fi
 783
 784        echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
 785        return 1
 786}
 787
 788# test_cmp is a helper function to compare actual and expected output.
 789# You can use it like:
 790#
 791#       test_expect_success 'foo works' '
 792#               echo expected >expected &&
 793#               foo >actual &&
 794#               test_cmp expected actual
 795#       '
 796#
 797# This could be written as either "cmp" or "diff -u", but:
 798# - cmp's output is not nearly as easy to read as diff -u
 799# - not all diff versions understand "-u"
 800
 801test_cmp() {
 802        $GIT_TEST_CMP "$@"
 803}
 804
 805# This function can be used to schedule some commands to be run
 806# unconditionally at the end of the test to restore sanity:
 807#
 808#       test_expect_success 'test core.capslock' '
 809#               git config core.capslock true &&
 810#               test_when_finished "git config --unset core.capslock" &&
 811#               hello world
 812#       '
 813#
 814# That would be roughly equivalent to
 815#
 816#       test_expect_success 'test core.capslock' '
 817#               git config core.capslock true &&
 818#               hello world
 819#               git config --unset core.capslock
 820#       '
 821#
 822# except that the greeting and config --unset must both succeed for
 823# the test to pass.
 824#
 825# Note that under --immediate mode, no clean-up is done to help diagnose
 826# what went wrong.
 827
 828test_when_finished () {
 829        test_cleanup="{ $*
 830                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 831}
 832
 833# Most tests can use the created repository, but some may need to create more.
 834# Usage: test_create_repo <directory>
 835test_create_repo () {
 836        test "$#" = 1 ||
 837        error "bug in the test script: not 1 parameter to test-create-repo"
 838        repo="$1"
 839        mkdir -p "$repo"
 840        (
 841                cd "$repo" || error "Cannot setup test environment"
 842                "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
 843                error "cannot run git init -- have you built things yet?"
 844                mv .git/hooks .git/hooks-disabled
 845        ) || exit
 846}
 847
 848test_done () {
 849        GIT_EXIT_OK=t
 850
 851        if test -z "$HARNESS_ACTIVE"; then
 852                test_results_dir="$TEST_DIRECTORY/test-results"
 853                mkdir -p "$test_results_dir"
 854                test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 855
 856                cat >>"$test_results_path" <<-EOF
 857                total $test_count
 858                success $test_success
 859                fixed $test_fixed
 860                broken $test_broken
 861                failed $test_failure
 862
 863                EOF
 864        fi
 865
 866        if test "$test_fixed" != 0
 867        then
 868                say_color pass "# fixed $test_fixed known breakage(s)"
 869        fi
 870        if test "$test_broken" != 0
 871        then
 872                say_color error "# still have $test_broken known breakage(s)"
 873                msg="remaining $(($test_count-$test_broken)) test(s)"
 874        else
 875                msg="$test_count test(s)"
 876        fi
 877        case "$test_failure" in
 878        0)
 879                # Maybe print SKIP message
 880                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 881
 882                if test $test_external_has_tap -eq 0; then
 883                        say_color pass "# passed all $msg"
 884                        say "1..$test_count$skip_all"
 885                fi
 886
 887                test -d "$remove_trash" &&
 888                cd "$(dirname "$remove_trash")" &&
 889                rm -rf "$(basename "$remove_trash")"
 890
 891                exit 0 ;;
 892
 893        *)
 894                if test $test_external_has_tap -eq 0; then
 895                        say_color error "# failed $test_failure among $msg"
 896                        say "1..$test_count"
 897                fi
 898
 899                exit 1 ;;
 900
 901        esac
 902}
 903
 904# Test the binaries we have just built.  The tests are kept in
 905# t/ subdirectory and are run in 'trash directory' subdirectory.
 906if test -z "$TEST_DIRECTORY"
 907then
 908        # We allow tests to override this, in case they want to run tests
 909        # outside of t/, e.g. for running tests on the test library
 910        # itself.
 911        TEST_DIRECTORY=$(pwd)
 912fi
 913GIT_BUILD_DIR="$TEST_DIRECTORY"/..
 914
 915if test -n "$valgrind"
 916then
 917        make_symlink () {
 918                test -h "$2" &&
 919                test "$1" = "$(readlink "$2")" || {
 920                        # be super paranoid
 921                        if mkdir "$2".lock
 922                        then
 923                                rm -f "$2" &&
 924                                ln -s "$1" "$2" &&
 925                                rm -r "$2".lock
 926                        else
 927                                while test -d "$2".lock
 928                                do
 929                                        say "Waiting for lock on $2."
 930                                        sleep 1
 931                                done
 932                        fi
 933                }
 934        }
 935
 936        make_valgrind_symlink () {
 937                # handle only executables, unless they are shell libraries that
 938                # need to be in the exec-path.  We will just use "#!" as a
 939                # guess for a shell-script, since we have no idea what the user
 940                # may have configured as the shell path.
 941                test -x "$1" ||
 942                test "#!" = "$(head -c 2 <"$1")" ||
 943                return;
 944
 945                base=$(basename "$1")
 946                symlink_target=$GIT_BUILD_DIR/$base
 947                # do not override scripts
 948                if test -x "$symlink_target" &&
 949                    test ! -d "$symlink_target" &&
 950                    test "#!" != "$(head -c 2 < "$symlink_target")"
 951                then
 952                        symlink_target=../valgrind.sh
 953                fi
 954                case "$base" in
 955                *.sh|*.perl)
 956                        symlink_target=../unprocessed-script
 957                esac
 958                # create the link, or replace it if it is out of date
 959                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 960        }
 961
 962        # override all git executables in TEST_DIRECTORY/..
 963        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 964        mkdir -p "$GIT_VALGRIND"/bin
 965        for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
 966        do
 967                make_valgrind_symlink $file
 968        done
 969        # special-case the mergetools loadables
 970        make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
 971        OLDIFS=$IFS
 972        IFS=:
 973        for path in $PATH
 974        do
 975                ls "$path"/git-* 2> /dev/null |
 976                while read file
 977                do
 978                        make_valgrind_symlink "$file"
 979                done
 980        done
 981        IFS=$OLDIFS
 982        PATH=$GIT_VALGRIND/bin:$PATH
 983        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 984        export GIT_VALGRIND
 985elif test -n "$GIT_TEST_INSTALLED" ; then
 986        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 987        error "Cannot run git from $GIT_TEST_INSTALLED."
 988        PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
 989        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 990else # normal case, use ../bin-wrappers only unless $with_dashes:
 991        git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
 992        if ! test -x "$git_bin_dir/git" ; then
 993                if test -z "$with_dashes" ; then
 994                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 995                fi
 996                with_dashes=t
 997        fi
 998        PATH="$git_bin_dir:$PATH"
 999        GIT_EXEC_PATH=$GIT_BUILD_DIR
1000        if test -n "$with_dashes" ; then
1001                PATH="$GIT_BUILD_DIR:$PATH"
1002        fi
1003fi
1004GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
1005unset GIT_CONFIG
1006GIT_CONFIG_NOSYSTEM=1
1007GIT_ATTR_NOSYSTEM=1
1008export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
1009
1010. "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
1011
1012if test -z "$GIT_TEST_CMP"
1013then
1014        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
1015        then
1016                GIT_TEST_CMP="$DIFF -c"
1017        else
1018                GIT_TEST_CMP="$DIFF -u"
1019        fi
1020fi
1021
1022GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
1023export GITPERLLIB
1024test -d "$GIT_BUILD_DIR"/templates/blt || {
1025        error "You haven't built things yet, have you?"
1026}
1027
1028if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
1029then
1030        GITPYTHONLIB="$GIT_BUILD_DIR/git_remote_helpers/build/lib"
1031        export GITPYTHONLIB
1032        test -d "$GIT_BUILD_DIR"/git_remote_helpers/build || {
1033                error "You haven't built git_remote_helpers yet, have you?"
1034        }
1035fi
1036
1037if ! test -x "$GIT_BUILD_DIR"/test-chmtime; then
1038        echo >&2 'You need to build test-chmtime:'
1039        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
1040        exit 1
1041fi
1042
1043# Test repository
1044test="trash directory.$(basename "$0" .sh)"
1045test -n "$root" && test="$root/$test"
1046case "$test" in
1047/*) TRASH_DIRECTORY="$test" ;;
1048 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
1049esac
1050test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
1051rm -fr "$test" || {
1052        GIT_EXIT_OK=t
1053        echo >&5 "FATAL: Cannot prepare test area"
1054        exit 1
1055}
1056
1057HOME="$TRASH_DIRECTORY"
1058export HOME
1059
1060test_create_repo "$test"
1061# Use -P to resolve symlinks in our working directory so that the cwd
1062# in subprocesses like git equals our $PWD (for pathname comparisons).
1063cd -P "$test" || exit 1
1064
1065this_test=${0##*/}
1066this_test=${this_test%%-*}
1067for skp in $GIT_SKIP_TESTS
1068do
1069        case "$this_test" in
1070        $skp)
1071                say_color skip >&3 "skipping test $this_test altogether"
1072                skip_all="skip all tests in $this_test"
1073                test_done
1074        esac
1075done
1076
1077# Provide an implementation of the 'yes' utility
1078yes () {
1079        if test $# = 0
1080        then
1081                y=y
1082        else
1083                y="$*"
1084        fi
1085
1086        while echo "$y"
1087        do
1088                :
1089        done
1090}
1091
1092# Fix some commands on Windows
1093case $(uname -s) in
1094*MINGW*)
1095        # Windows has its own (incompatible) sort and find
1096        sort () {
1097                /usr/bin/sort "$@"
1098        }
1099        find () {
1100                /usr/bin/find "$@"
1101        }
1102        sum () {
1103                md5sum "$@"
1104        }
1105        # git sees Windows-style pwd
1106        pwd () {
1107                builtin pwd -W
1108        }
1109        # no POSIX permissions
1110        # backslashes in pathspec are converted to '/'
1111        # exec does not inherit the PID
1112        test_set_prereq MINGW
1113        test_set_prereq SED_STRIPS_CR
1114        ;;
1115*CYGWIN*)
1116        test_set_prereq POSIXPERM
1117        test_set_prereq EXECKEEPSPID
1118        test_set_prereq NOT_MINGW
1119        test_set_prereq SED_STRIPS_CR
1120        ;;
1121*)
1122        test_set_prereq POSIXPERM
1123        test_set_prereq BSLASHPSPEC
1124        test_set_prereq EXECKEEPSPID
1125        test_set_prereq NOT_MINGW
1126        ;;
1127esac
1128
1129test -z "$NO_PERL" && test_set_prereq PERL
1130test -z "$NO_PYTHON" && test_set_prereq PYTHON
1131test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
1132test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
1133
1134# Can we rely on git's output in the C locale?
1135if test -n "$GETTEXT_POISON"
1136then
1137        GIT_GETTEXT_POISON=YesPlease
1138        export GIT_GETTEXT_POISON
1139        test_set_prereq GETTEXT_POISON
1140else
1141        test_set_prereq C_LOCALE_OUTPUT
1142fi
1143
1144# Use this instead of test_cmp to compare files that contain expected and
1145# actual output from git commands that can be translated.  When running
1146# under GETTEXT_POISON this pretends that the command produced expected
1147# results.
1148test_i18ncmp () {
1149        test -n "$GETTEXT_POISON" || test_cmp "$@"
1150}
1151
1152# Use this instead of "grep expected-string actual" to see if the
1153# output from a git command that can be translated either contains an
1154# expected string, or does not contain an unwanted one.  When running
1155# under GETTEXT_POISON this pretends that the command produced expected
1156# results.
1157test_i18ngrep () {
1158        if test -n "$GETTEXT_POISON"
1159        then
1160            : # pretend success
1161        elif test "x!" = "x$1"
1162        then
1163                shift
1164                ! grep "$@"
1165        else
1166                grep "$@"
1167        fi
1168}
1169
1170# test whether the filesystem supports symbolic links
1171ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1172rm -f y
1173
1174# When the tests are run as root, permission tests will report that
1175# things are writable when they shouldn't be.
1176test -w / || test_set_prereq SANITY